function varargout = BredeQuery(varargin)
%BREDEQUERY M-file for BredeQuery.fig
%   BREDEQUERY, by itself, creates a new BREDEQUERY or raises the existing
%   singleton*.
%
%   H = BREDEQUERY returns the handle to a new BREDEQUERY or the handle to
%   the existing singleton*.
%
%   BREDEQUERY('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in BREDEQUERY.M with the given input arguments.
%
%   BREDEQUERY('Property','Value',...) creates a new BREDEQUERY or raises the
%   existing singleton*.  Starting from the left, property value pairs are
%   applied to the GUI before BredeQuery_OpeningFunction gets called.  An
%   unrecognized property name or invalid value makes property application
%   stop.  All inputs are passed to BredeQuery_OpeningFcn via varargin.
%
%   *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%   instance to run (singleton)".
%
%   See also BREDEQUERY_WEB, GUIDE, GUIDATA, GUIHANDLES.
%
%   Copyright 2007-2008 Technical University of Denmark
%   $Revision: 1.19 $  $Date: 2008/06/23 14:54:33 $
  
% Edit the above text to modify the response to help BredeQuery

% Bartlomiej Wilkowski
% Informatics and Mathematical Modelling
% Technical University of Denmark
% bw@imm.dtu.dk
% 2007/10/15
% Last Modified by GUIDE v2.5 21-May-2008 16:33:29
% Last modified: 2009/03/12 - bw

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @BredeQuery_OpeningFcn, ...
                   'gui_OutputFcn',  @BredeQuery_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before BredeQuery is made visible.
function BredeQuery_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to BredeQuery (see VARARGIN)

% Choose default command line output for BredeQuery
handles.output = hObject;
handles.infoLabelInitText = 'Retrieved co-ordinates';

jarLoc = which('BredeXMLExporter.jar');


%Bypassing the Matlab bug: the javaaddpath clears SPM variables through
%clear('java') function. Thus, the defaults are saved before calling
%javaaddpath and retrieved just after.
global defaults;
tempDefaults = defaults;

javaaddpath(jarLoc);

global defaults;
defaults = tempDefaults;

handles.jarpath = jarLoc;
% Update handles structure
guidata(hObject, handles);

set(handles.coordinatesList,'String','');
getCoordinatesFromGraphics(hObject, eventdata, handles);

% UIWAIT makes BredeQuery wait for user response (see UIRESUME)
% uiwait(handles.figure1);


%This function takes all the brain activity locations (coordinates) from
%the SPM window in order to display them on the BredeQuery plugin list.
function getCoordinatesFromGraphics(hObject, eventdata, handles)
     
A = [];
hh = findobj('tag', 'TD_Xdat');
if length(hh) == 2
    A = get(get(hh(1), 'parent'), 'userdata');
end         
      
if ~isempty(A)
 switch(get(handles.choose_alg,'Value'))
        case {1}
            alg = 'lancaster';            
        case {2}
            alg = 'brett';            
        case {3}
            alg = 'none';                    
 end
 if(strcmp(alg,'lancaster')) 
    switch(get(handles.lancaster_type,'Value'))
            case {1}
                lanc_type = 'spm';                
            case {2}
                lanc_type = 'fsl';
            case {3}
                lanc_type = 'pooled';                    
    end
 end
    
 algtxt = alg;
  % Field out the field in the 'loc' structure from the SPM table. 
  for n = 1:size(A.dat,1)
    L{n}.coordReported = A.dat{n,11}';
    L{n}.xReported     = L{n}.coordReported(1);  
    L{n}.yReported     = L{n}.coordReported(2);  
    L{n}.zReported     = L{n}.coordReported(3);  
    L{n}.coord         = L{n}.coordReported;
    
    if(strcmp(alg,'lancaster'))        
        
        algtxt = [alg ' -> ' lanc_type];
        coords = bredequery_lancaster_mni2tal(L{n}.coord,lanc_type);
    else if(strcmp(alg,'brett'))
            coords = bredequery_mni2tal(L{n}.coord);
        else if (strcmp(alg,'none'))
                coords = L{n}.coord;    
            end
        end
    end
    coords = round(coords);
    Lstr{n} = num2str(coords);
  end

  set(handles.coordinatesList,'String',Lstr); 
  set(handles.infoLabel,'String',([handles.infoLabelInitText ' (' algtxt ')']));
  
end

% --- Outputs from this function are returned to the command line.
function varargout = BredeQuery_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on selection change in coordinatesList.
function coordinatesList_Callback(hObject, eventdata, handles)
% hObject    handle to coordinatesList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns coordinatesList contents as cell array
%        contents{get(hObject,'Value')} returns selected item from coordinatesList

A = get(handles.coordinatesList,'String');
i = get(handles.coordinatesList,'Value');
checked = get(handles.interactiveModeChckBut,'Value');
if(checked~=0 && ~isempty(i)) 
    A = [];
    hh = findobj('tag', 'TD_Xdat');
    if length(hh) == 2
        A = get(get(hh(1), 'parent'), 'userdata');
    end 
    if(~isscalar(i))
        coordReported = A.dat{i(1),11}';
    else    
        coordReported = A.dat{i,11}';
    end
    spm_mip_ui('SetCoords', coordReported, findobj('tag', 'hMIPax'));
end

% --- Executes during object creation, after setting all properties.
function coordinatesList_CreateFcn(hObject, eventdata, handles)
% hObject    handle to coordinatesList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in manualQueryChkBox.
function manualQueryChkBox_Callback(hObject, eventdata, handles)
% hObject    handle to manualQueryChkBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of manualQueryChkBox
% if(strcmp(get(handles.manualQueryTField,'Enable'),'off'))   
%     set(handles.manualQueryTField,'Enable','On');
%     
%     
%     set(handles.coordinatesList,'Enable','Off');
%     set(handles.manualQueryChkBox,'String','Manual query ON');
%     
%    
% else
%     set(handles.manualQueryTField,'Enable','Off');
%     set(handles.manualQueryTField,'String','');
%     set(handles.coordinatesList,'Enable','On');
%     set(handles.manualQueryChkBox,'String','Manual query OFF');
% end


function manualQueryTField_Callback(hObject, eventdata, handles)
% hObject    handle to manualQueryTField (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of manualQueryTField as text
%        str2double(get(hObject,'String')) returns contents of manualQueryTField as a double


% --- Executes during object creation, after setting all properties.
function manualQueryTField_CreateFcn(hObject, eventdata, handles)
% hObject    handle to manualQueryTField (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in queryButton. This function query the
% Brede database and display the web page with the retrieved query results.
function queryButton_Callback(hObject, eventdata, handles)
% hObject    handle to queryButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if strcmp(get(handles.coordinatesList,'Enable'),'on')
    i = get(handles.coordinatesList,'Value');
    A = get(handles.coordinatesList,'String');
    query = '';
   
    for j=1:size(i(:))
        query = [query A{i(j)} ';'];
    end
    
else
    query = get(handles.manualQueryTField,'String');
end
bredequery_web(query,get(handles.withExpCheckbox,'Value'));


% --- Executes on button press in refreshButton.
%function refreshButton_Callback(hObject, eventdata, handles)
% hObject    handle to refreshButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%set(handles.coordinatesList,'String','');
%getCoordinatesFromGraphics(hObject, eventdata, handles);

% --- Executes on button press in withExpCheckbox.
function withExpCheckbox_Callback(hObject, eventdata, handles)
% hObject    handle to withExpCheckbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of withExpCheckbox


% % --- Executes on button press in selectAllButton.
% function selectAllButton_Callback(hObject, eventdata, handles)
% % hObject    handle to selectAllButton (see GCBO)
% % eventdata  reserved - to be defined in a future version of MATLAB
% % handles    structure with handles and user data (see GUIDATA)
% if(strcmp(get(handles.selectAllButton,'String'),'Select All'))
%    set(handles.selectAllButton,'String','Select Single'); 
%    val = size(get(handles.coordinatesList,'String'),1);
%    if(val>100)
%        val=100;
%    end
%    set(0,'RecursionLimit',110);
%    set(handles.coordinatesList,'Value',1:100);
% else if(strcmp(get(handles.selectAllButton,'String'),'Select Single'))
%    set(handles.selectAllButton,'String','Select All');
%    set(handles.coordinatesList,'Value',1);
%     end
% end


% --- Executes on selection change in choose_alg.
function choose_alg_Callback(hObject, eventdata, handles)
% hObject    handle to choose_alg (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns choose_alg contents as cell array
%        contents{get(hObject,'Value')} returns selected item from choose_alg
if(get(hObject,'Value')~=1)
    set(handles.lancaster_type,'Visible','off');
    set(handles.coordinatesList,'String','');
    getCoordinatesFromGraphics(hObject, eventdata, handles);
else
    set(handles.lancaster_type,'Visible','on');
    set(handles.coordinatesList,'String','');
    getCoordinatesFromGraphics(hObject, eventdata, handles);
end

% --- Executes during object creation, after setting all properties.
function choose_alg_CreateFcn(hObject, eventdata, handles)
% hObject    handle to choose_alg (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in lancaster_type.
function lancaster_type_Callback(hObject, eventdata, handles)
% hObject    handle to lancaster_type (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns lancaster_type contents as cell array
%        contents{get(hObject,'Value')} returns selected item from lancaster_type
set(handles.coordinatesList,'String','');
getCoordinatesFromGraphics(hObject, eventdata, handles);

% --- Executes during object creation, after setting all properties.
function lancaster_type_CreateFcn(hObject, eventdata, handles)
% hObject    handle to lancaster_type (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in exportToAllButton. This function uses the
% external JAR file (the Java-source code is packed inside the JAR file) in
% order to generate the output files from the query to BredeDatabase
% (BiBTeX file, RefWorks file, ReferenceManager file, EndNote file).
function exportToAllButton_Callback(hObject, eventdata, handles)
% hObject    handle to exportToAllButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

import imm.brede.plugin.*
import java.lang.String

if strcmp(get(handles.coordinatesList,'Enable'),'on')
    i = get(handles.coordinatesList,'Value');
    A = get(handles.coordinatesList,'String');
    query = A{i(1)};           
else
    query = get(handles.manualQueryTField,'String');
end

strQuery = String(query);

switch(get(handles.choose_alg,'Value'))
    case {1}
        alg = 'lancaster';            
    case {2}
        alg = 'brett';            
    case {3}
        alg = 'none';                    
end
algtxt = alg;
if(strcmp(alg,'lancaster'))        
    switch(get(handles.lancaster_type,'Value'))
        case {1}
            lanc_type = 'spm';                
        case {2}
            lanc_type = 'fsl';
        case {3}
            lanc_type = 'pooled';                    
    end
    algtxt = [alg ' -> ' lanc_type];
end

path = uigetdir(handles.jarpath,'Select directory for export files');
if(path~=0)
    d = BredeXMLConverter(String(path), strQuery, String(algtxt));
    if(d.getBredeXML()~=0)
        d.createInfoFile();
        if(get(handles.bibtexchbx,'Value')==1)
            d.convertToBibTeX(d.getXmlFile());
        end
        if(get(handles.refmanchbx,'Value')==1)
            d.convertToRefMan(d.getXmlFile());
        end
        if(get(handles.endnotechbx,'Value')==1)
            d.convertToEndNote(d.getXmlFile());
        end
        if(get(handles.refworkschbx,'Value')==1)
            d.convertToRefWorks(d.getXmlFile());
        end
    end
end


% --- Executes on button press in bibtexchbx.
function bibtexchbx_Callback(hObject, eventdata, handles)
% hObject    handle to bibtexchbx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of bibtexchbx


% --- Executes on button press in refmanchbx.
function refmanchbx_Callback(hObject, eventdata, handles)
% hObject    handle to refmanchbx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of refmanchbx


% --- Executes on button press in endnotechbx.
function endnotechbx_Callback(hObject, eventdata, handles)
% hObject    handle to endnotechbx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of endnotechbx


% --- Executes on button press in refworkschbx.
function refworkschbx_Callback(hObject, eventdata, handles)
% hObject    handle to refworkschbx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of refworkschbx


% --- Executes on button press in grabrb.
function grabrb_Callback(hObject, eventdata, handles)
% hObject    handle to grabrb (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

grabbing(handles);

% Hint: get(hObject,'Value') returns toggle state of grabrb


% --- Executes on button press in manualrb.
function manualrb_Callback(hObject, eventdata, handles)
% hObject    handle to manualrb (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

manual(handles);

% Hint: get(hObject,'Value') returns toggle state of manualrb

%findobj('-regexp','tag', '.*MIPax')
%spm_mip_ui('FindMIPax',findobj('tag', 'hMIPax'))
%spm_mip_ui('SetCoords', [54 -50 64], findobj('tag', 'hMIPax'));


function manual(handles)

set(handles.manualrb,'Value',1);
set(handles.grabrb,'Value',0);
set(handles.manualQueryTField,'Enable','On');
set(handles.coordinatesList,'Value',zeros(1,0));
set(handles.coordinatesList,'Enable','Off');
set(handles.automaticMarkButton,'Enable','Off');
set(handles.manualMarkButton,'Enable','On');
set(handles.interactiveModeChckBut,'Enable','Off');
set(handles.grabCoordButton,'Enable','Off');

function grabbing(handles)

set(handles.grabrb,'Value',1);
set(handles.manualrb,'Value',0);
set(handles.manualQueryTField,'Enable','Off');
set(handles.manualQueryTField,'String','');
set(handles.coordinatesList,'Enable','On');
set(handles.automaticMarkButton,'Enable','On');
set(handles.manualMarkButton,'Enable','Off');
set(handles.interactiveModeChckBut,'Enable','On');
set(handles.grabCoordButton,'Enable','On');


% --- Executes on button press in feedbackButton.
function feedbackButton_Callback(hObject, eventdata, handles)
% hObject    handle to feedbackButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
web('http://neuroinf.imm.dtu.dk/BredeQuery/brede_spm_plugin_feedback.html', '-new');

% --- Executes on button press in automaticMarkButton. This function
% selects and marks on the plugin's list the recently selected activation
% (marked on the SPM window in red as a small arrow). Allow the user to
% query the Brede database especially for the specific, previously
% selected activation.
function automaticMarkButton_Callback(hObject, eventdata, handles)
% hObject    handle to automaticMarkButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

switch(get(handles.choose_alg,'Value'))
        case {1}
            alg = 'lancaster';            
        case {2}
            alg = 'brett';            
        case {3}
            alg = 'none';                    
end
if(strcmp(alg,'lancaster')) 
    switch(get(handles.lancaster_type,'Value'))
            case {1}
                lanc_type = 'spm';                
            case {2}
                lanc_type = 'fsl';
            case {3}
                lanc_type = 'pooled';                    
    end
end

redValues = get(findobj('color', [1 0 0], '-and', 'tag', 'ListXYZ'), 'UserData')
if(size(redValues,1)==3)
    Lstr = get(handles.coordinatesList,'String');   

    if(strcmp(alg,'lancaster'))          
            redValuesTr = round(bredequery_lancaster_mni2tal(redValues',lanc_type));
        else if(strcmp(alg,'brett'))
                redValuesTr = round(bredequery_mni2tal(redValues'));        
            else if(strcmp(alg,'none'))
                redValuesTr = redValues';
                end
            end
    end 

    for n=1:size(Lstr)'
        val=str2num(Lstr{n}); 
        if(val==redValuesTr)
            set(handles.coordinatesList,'Value',n);
            break;
        end
    end

end


% --- Executes on button press in grabCoordButton.
function grabCoordButton_Callback(hObject, eventdata, handles)
% hObject    handle to grabCoordButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.coordinatesList,'String','');
getCoordinatesFromGraphics(hObject, eventdata, handles);


% --- Executes on button press in interactiveModeChckBut.
function interactiveModeChckBut_Callback(hObject, eventdata, handles)
% hObject    handle to interactiveModeChckBut (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of interactiveModeChckBut


% --- Executes on button press in manualMarkButton.
function manualMarkButton_Callback(hObject, eventdata, handles)
% hObject    handle to manualMarkButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
switch(get(handles.choose_alg,'Value'))
        case {1}
            alg = 'lancaster';            
        case {2}
            alg = 'brett';            
        case {3}
            alg = 'none';                    
end
if(strcmp(alg,'lancaster')) 
    switch(get(handles.lancaster_type,'Value'))
            case {1}
                lanc_type = 'spm';                
            case {2}
                lanc_type = 'fsl';
            case {3}
                lanc_type = 'pooled';                    
    end
end

selected = get(findobj('tag', 'hMIPxyz'), 'string');
selected = str2num(selected{2});

if(strcmp(alg,'lancaster'))          
    selectedTr = round(bredequery_lancaster_mni2tal(selected,lanc_type));
else if(strcmp(alg,'brett'))
        selectedTr = round(bredequery_mni2tal(selected));        
    else if(strcmp(alg,'none'))
        selectedTr = selected;
        end
    end
end 

set(handles.manualQueryTField,'String',num2str(selectedTr));
        

