package imm.brede.plugin;

import java.util.Vector;

import javax.swing.JOptionPane;

/**
 * 
 * @author Bartlomiej Wilkowski Technical University of Denmark, Informatics and
 *         Mathematical Modelling, 2800 Kogens, Lyngby bw@imm.dtu.dk
 * 
 * Creation date: 2007-11-28
 * 
 */
public class BredeUtils {

	/**
	 * This method is able to extract the 3D integer coordinates from a given
	 * String The three coordinates should be separated with either spaces or
	 * commas. All trailing and leading spaces are omitted.
	 * 
	 * @param point -
	 *            a point coordinates in String format
	 * @return the array of integers (three coordinates), null if exception
	 *         thrown.
	 */
	public static int[] extract3DCoordinates(String point) {

		char separator;
		if (point.indexOf(',') != -1)
			separator = ',';
		else
			separator = ' ';

		int[] coords = new int[3];
		int coordinate;
		String singleCoord = "";
		for (int i = 0; i < 3; i++) {
			try {
				point = point.trim();
				if (i < 2) {
					coordinate = point.indexOf(separator);
					singleCoord = point.substring(0, coordinate);
					point = point.substring(coordinate + 1);
				} else {
					singleCoord = point;
				}
				coords[i] = new Integer(singleCoord).intValue();
			} catch (Exception e) {
				JOptionPane.showMessageDialog(null,
						"Incorrectly formatted query.");
				return null;
			}
		}
		return coords;
	}

	/**
	 * 
	 * @param authors
	 * @return
	 */
	public static Vector<String> extractAuthors(String authors) {
		
		Vector<String> authorList = new Vector<String>();
		String temp;
		String rest = authors;
		int index;
		while ((index = rest.indexOf(';')) != -1) {
			temp = rest.substring(0, index);
			temp = temp.trim();
			rest = rest.substring(index + 1);
			rest = rest.trim();
			authorList.add(temp);
		}
		authorList.add(rest);

		return authorList;
	}

}
