package imm.brede.plugin.bibtex;


import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.util.Date;
import java.util.Vector;

/**
 * 
 * @author Bartlomiej Wilkowski Technical University of Denmark, Informatics and
 *         Mathematical Modelling, 2800 Kogens, Lyngby bw@imm.dtu.dk
 * 
 * Creation date: 2007-11-28
 * 
 */
public class BibTeXWriter {

	/**
	 * 
	 * @param articles
	 * @param bibtex
	 */
	public static void createBibTeXFile(Vector<BibTeXArticle> articles,
			File bibtex) {

		FileOutputStream fos;
		String date = new String(new Date(System.currentTimeMillis())
				.toString());
		try {
			fos = new FileOutputStream(bibtex);
			PrintWriter osw = new PrintWriter(fos);
			osw.println("BibTeX references generated by Brede-SPM plugin.");
			osw.println("Generation date: " + date.substring(4, 7) + "/"
					+ date.substring(8, 10) + "/"
					+ date.substring(date.length() - 4, date.length()));
			osw.println("");
			osw.println("");
			
			BibTeXArticle article = null;
			for(int i=0;i<articles.size();i++){
				article = articles.elementAt(i);
				osw.println(article.toString());
				osw.println("\n");				
			}			
			
			osw.flush();
			osw.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

}
