package imm.brede.plugin.endnote;

import java.util.Vector;

import imm.brede.plugin.Article;

/**
 * 
 * @author Bartlomiej Wilkowski
 * Technical University of Denmark,
 * Informatics and Mathematical Modelling,
 * 2800 Kogens, Lyngby
 * bw@imm.dtu.dk
 * 
 * Creation date: 2007-12-04
 *
 */
public class EndNoteArticle extends Article{
	
	public String getAuthorsInEndNoteFormat() {
		String text = "";

		String connector = "\n";
		Vector<String> authors = getAuthors();
		String temp;
		String surn;
		String name;
		int ind;
		for (int i = 0; i < authors.size(); i++) {
			temp = authors.elementAt(i);
			temp = temp.trim();
			ind = temp.lastIndexOf(' ');
			if (ind != -1) {
				surn = temp.substring(ind + 1);
				surn = surn.trim();
				name = temp.substring(0, ind);
				name = name.trim();
				temp = surn.concat(", ");
				temp = temp.concat(name);
			}
			temp = "%A " + temp;
			text = text.concat(temp);
			text = text.concat(connector);
		}

		return text;
	}
	
	@Override
	public String toString() {
		String description = "\n\n"+getAuthorsInEndNoteFormat()+"%T "+getTitle()+"\n" +
				"%D "+getYear()+"\n%J "+getJournal()+"\n%P "+getPages()+"\n" +
						"%V "+getVolume()+"\n%N "+getNumber()+"\n\n\n";
		return description;
	}

}
