package imm.brede.plugin.refman;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.util.Vector;

/**
 * 
 * @author Bartlomiej Wilkowski
 * Technical University of Denmark,
 * Informatics and Mathematical Modelling,
 * 2800 Kogens, Lyngby
 * bw@imm.dtu.dk
 * 
 * Creation date: 2007-12-04
 *
 */
public class RefManWriter {
	
	/**
	 * 
	 * @param articles
	 * @param refman
	 */
	public static void createRefManFile(Vector<RefManJournal> articles,
			File refman) {

		FileOutputStream fos;
		/*String date = new String(new Date(System.currentTimeMillis())
				.toString());*/
		try {
			fos = new FileOutputStream(refman);
			PrintWriter osw = new PrintWriter(fos);
			/*osw.println("Ref references generated by Brede-SPM plugin.");
			osw.println("Generation date: " + date.substring(4, 7) + "/"
					+ date.substring(8, 10) + "/"
					+ date.substring(date.length() - 4, date.length()));
			osw.println("");*/
			osw.println("");
			
			RefManJournal article = null;
			for(int i=0;i<articles.size();i++){
				article = articles.elementAt(i);
				osw.println(article.toString());
				osw.println("\n");				
			}			
			
			osw.flush();
			osw.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}
}
